* SB function VLOAD
*
* pjwitte 1986..2oo3
*
* V0.02 August 10th 2003 Wrong file version returns err_bn, not err_nf
* V0.03, pjw, 2022 Jun 13, Added extra check for OV, updated read, fixed
*                          skip bug
*
* VLOAD - ERT VLOAD(<filename>, <var1> [,<var2> ..])
*
* where <var> is either a pre-dimensioned array or scalar variable
*
        section code

        xdef VLOAD

        xref    sentinel
        xref    check_pars,get_open,close,soft_err,hard_err
        xref    read,readb,trap3,arr_size,load
        xref    arr_info,retarrf
        xref    parinfo,resrir  ;seperate modules at present -> library
        xref    retpat          ;seperate modules at present -> library
VLOAD
        bsr     sentinel        ;d4 = empty stack pointer
        bsr     check_pars      ;d7 = num pars, min 1 (excl filename)
        moveq   #1,d3           ;ready to open file for READ only
        bsr     get_open        ;a0 = chan id, don't return if param error
        bne     soft_err        ;file errors are soft
        moveq   #6,d2
        bsr     readb           ;get first six bytes
        cmpi.l  #'VS01',0(a6,a1.l) ;old acquaintance?
        bne.s   soft_bn
        moveq   #0,d3           ;d3 = last "parsing" error
        move.w  4(a6,a1.l),d0   ;number of vars in file
        cmp.w   d0,d7           ;use smallest number as counter
        bls.s   vl_0
        moveq   #-10,d3         ;more parameters than we have => eof
        move.w  d0,d7
        bra.s   vl_1
vl_0
        beq.s   vl_1
        moveq   #-1,d3          ;more stored variables than parameters => nc
vl_1
        subq.w  #1,d7
vl_loop
        moveq   #6,d2           ;read 6 bytes
        bsr     readb           ;get skip length and type into buffer
        movea.l (a6),a4         ;a4 -> the stored parameter details
        move.l  0(a6,a4.l),d1   ;d1 = skip length
        subq.l  #6,d1           ;we've already skipped this bit
        bsr     parinfo
        bra.s   vl_skip         ;skip nul parameters
        bra.s   vl_scalar
        bra.s   vl_array
vl_scalar
        btst    #7,d0           ;save a moment by skipping expression
        bne.s   vl_skip
        move.l  d1,d2           ;d1 = number of stack bytes for this parameter
        bsr     resrir          ;reserve var size number of bytes on RI stack
        bsr     read            ; and read var onto stack
        move.b  5(a6,a4.l),d0   ;this is the type of the stored variable
        move.w  d5,d1           ; and this is the parameter type
        bsr     retpat          ;convert, if necessary and stuff in parameter
        bne.s   soft_rts
vl_lend
        dbra    d7,vl_loop
        move.l  d3,d0           ;return last "parsing" error
*
soft_rts
        bra     soft_err
soft_bp
        moveq   #-15,d0
        bra.s   soft_rts
soft_bn
        moveq   #-12,d0
        bra.s   soft_rts
soft_ni
        moveq   #-19,d0
        bra.s   soft_rts
*
vl_skip                         ;skip d1.l bytes
        moveq   #$43,d0         ;iof.posr
        bsr     trap3           ;if error don't return
        addq.l  #8,a3           ;next par (V0.03)
        bra.s   vl_lend
*
vl_array
        tst.w   d0              ;more info on array
        bmi.s   soft_bp         ;unset array is baaaad
        btst    #7,d0           ;sub-array?
        bne.s   soft_ni         ;sub arrays not handled for now
        cmp.w   4(a6,a4.l),d5   ;are types same?
        bne.s   soft_bp         ; no, cannot load
        moveq   #2,d2           ;read no dims (2b) into buffer
        sub.l   d2,d1           ;reduce skip length
        movea.l a4,a1           ;a1 -> buffer
        bsr     read            ;a1/d1 preserved
        move.w  0(a6,a1.l),d2   ;d2 is number of dimensions
        lsl.w   #2,d2           ;number of bytes in array descriptor
        ext.l   d2
        sub.l   d2,d1           ;when we've read this, d1 bytes left to read
        addq.l  #2,a1           ;don't overwrite dimension count
        bsr     read            ;read descriptor. a4 still -> start of buffer
        move.l  d1,d2           ;d2 = size of array to load
        bsr     arr_info        ;get a1 -> 0'th element and d6 = no dimns
        bsr     arr_size        ;get d1 = size of array parameter
        bmi.s   soft_rts        ; V0.03
        bsr     retarrf         ;load array
        addq.l  #8,a3           ;point to next par
        tst.l   d1              ;any residual bytes to skip?
        beq.s   vl_lend         ; no, loop to next parameter
        bra.s   vl_skip         ; yes, so skip them
*
        end
