* General purpose routines to analyse and fetch parameters
* PWITTE May 9th 1995
*
        section code

        xdef arr_info,get_pat,get_scal,get_arr,arr_size

        xref getpars            ;win1_asm_sbu_par_getpars
        xref parinfo            ;win1_asm_sbu_par_parinfo
        xref resrir             ;win1_asm_sbu_uti_resrir
*
get_pat
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get parameter according to type
*
* input
*       a3   -> current parameter (must exist!)
* return
*       d5.w  = kind | type 2=scal, 3=arr | 1=str, 2=float, 3=int
*       d6.l  = array: number of dimensions, scalar: 0
*       a3   -> next parameter (or end) unless error
*       d0.l  = error (no return)
*       if scalar: d1.l  = length (2=int, 4=long, 2+len string (+1))
*                  a1   -> parameter
*       if array : d1.l  = size of array
*                  a1   -> 0'th element
*                  a2   -> array descriptor
*
        moveq   #0,d6           ;assume scalar
        bsr     parinfo
        bra.s   nul             ;nul   : nul or end
        bra.s   gt_pat          ;scalar: get scalar skipping test for type
        tst.w   d0              ;array : unset array?
        bmi.s   err_bp          ; yep (sbasic only), bad parameter here
        btst    #8,d0           ;sub-string?
        bne.s   gstr            ; yes, get it as a string
        bsr.s   arr_info
        bra.s   get_arr
nul
        bhi.s   gu_ok_next_exit ;null entry, point to next & return
err_bp
        moveq   #-15,d0         ;don't think we'll ever get here, but...
        rts
*
arr_info
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get array information
*
* input    cc = ???
*       a2   -> array descriptor
* return
*       d6.l  = number of dimensions
*       a1   -> 0'th element of array
*       no errors
*

        move.w  4(a6,a2.l),d6   ;d6 = number of dimensions
        movea.l 0(a6,a2.l),a1   ;a1 = offset from vv.bas to array
        adda.l  $28(a6),a1      ;vv.bas, presto!
        ext.l   d6              ; 'cause we promised
        rts
*
get_scal
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get scalar parameter according to type (pre-processed)
*
* input
*       d5.b  = type 1=str or substring, 2=float, 3=int
*       a3   -> current parameter (must exist!)
* return
*       d1.w  = length (2=int, 4=long, 6=float, 2+len string (+1))
*       a1   -> parameter
*       a3   -> next parameter (or end) unless error
*       d0.l  = error
*
        cmpi.b  #2,d5
gt_pat
        bmi.s   gstr
        beq.s   gtfp
gint
        moveq   #$10,d1
        bsr.s   get1par
        moveq   #2,d1           ;return length
        bra.s   gu_tst_exit
gtfp
        moveq   #$12,d1
        bsr.s   get1par
        moveq   #6,d1
        bra.s   gu_tst_exit
gstr
        moveq   #$14,d1
        bsr.s   get1par
        moveq   #3,d1
        add.w   0(a6,a1.l),d1
        bclr    #0,d1
gp_exit
        bra.s   gu_tst_exit
get1par
        tst.w   d0              ;test extra info returned from parinfo
        bmi.s   get_unset
        move.l  d3,-(a7)
        move.l  d1,d0           ;type of parameter to get
        bsr     getpars
        move.l  (a7)+,d3
        rts
get_unset
        moveq   #2,d1           ;assume integer/string
        cmpi.b  #2,d5           ;get type again
        bne.s   bvchr
nfp
        moveq   #6,d1
bvchr
        bsr     resrir
        clr.w   0(a6,a1.l)
        subq.l  #2,d1           ;float? (ie, more than 2 bytes)
        beq.s   gu_ok_next_exit ; no, string or int
        clr.l   2(a6,a1.l)      ;clear float mantissa
gu_ok_next_exit
        moveq   #0,d0
gu_next_exit
        addq.l  #8,a3           ;point to next parameter
gu_tst_exit
        tst.l   d0
gu_rts
        rts
*
*
get_arr
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get array parameter (pre-processed)
*
* input
*       d5.b  = type 1=str, 2=float, 3=int
*       d6.w  = number of dimensions
*       a2   -> array descriptor
*       a3   -> current parameter (must exist!)
* return
*       d1.l  = size of array in bytes
*       d6      preserved
*       a3   -> next parameter (or end) unless error
*       d0.l  = error (OV)
*
        bsr.s   arr_size
        bne.s   ga_rts
        addq.l  #8,a3           ;point to next parameter
ga_rts
        tst.l   d0
        rts
*
arr_size
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get array size
*
* input
*       d5.b  = type 1=str, 2=float, 3=int
*       d6.w  = number of dimensions
*       a2   -> array descriptor
* return
*       d1.l  = size of array in bytes
*       d6      preserved
*       d0.l  = error (OV)
*       no other regs affected
*
        move.l  a2,-(a7)
        move.l  d2,-(a7)
*
* First multiply dimensions of array together
*
        moveq   #1,d1
        move.w  d6,d0
        bra.s   mdl_end
md_loop
        move.w  6(a6,a2.l),d2
        addq.w  #1,d2           ;for the 0'th dimension
        mulu    d2,d1           ;d1 = product of all dimensions
        bvs.s   md_ov           ;oops! array too big (how did you do that?!)
        addq.l  #4,a2           ;next index
mdl_end
        dbra    d0,md_loop
*
* Now work out total size
*
        cmpi.b  #2,d5           ;what type?
        bmi.s   a_str
        beq.s   a_fp
        moveq   #2,d2           ;integer: bytes per element
        bra.s   a_size
a_str
        divu    d2,d1           ;(n+1) * size / n
        addq.w  #1,d2
        bra.s   a_size
md_ov
        moveq   #-18,d0
        bra.s   a_end
a_fp
        moveq   #6,d2           ;float: bytes per element
*
a_size                          ;d1=total number, d2=element size
        mulu    d2,d1           ;d1 = no. elements * bytes per element
        bvs.s   md_ov
        moveq   #0,d0           ;no errors
a_end
        movem.l (a7)+,d2/a2
        rts
*
        end
